//
//  DialogueHttpPostCmd.m
//  MobilePortal
//
//  Created by caiyang on 2020/4/10.
//  Copyright © 2020 yin chen. All rights reserved.
//

#import "DialogueHttpPostCmd.h"
#import "DialogueHttpPostResult.h"

static NSString *kActionUrl1 = @"/enterprise/activity/aiService";

@implementation DialogueHttpPostCmd

-(instancetype)initWithVersion:(NSString *)version{
    if ([version isEqualToString:PHttpVersion_v1]) {
        return [[DialogueHttpPostCmd alloc]initWithAuthorizationState:AuthorizationNull];
    }else{
        NSAssert(NO, @"Invalid version");
    }
    return nil;
}

- (instancetype)initWithAuthorizationState:(AuthorizationState)state{
    self = [super initWithAuthorizationState:state];
    if (self != nil) {
        self.result = [[DialogueHttpPostResult alloc]init];
    }
    return self;
}

- (NSString *)getActionUrl{
    
    return kActionUrl1;
}

@end
NSString * _Nonnull const kHttpDialogueHttpPostCmd_attr = @"attr";
NSString * _Nonnull const kHttpDialogueHttpPostCmd_filterString = @"filterString";
NSString * _Nonnull const kHttpDialogueHttpPostCmd_empid = @"empid";
NSString * _Nonnull const kHttpDialogueHttpPostCmd_orderby = @"orderby";
NSString * _Nonnull const kHttpDialogueHttpPostCmd_pageNum = @"pageNum";
NSString * _Nonnull const kHttpDialogueHttpPostCmd_pageSize = @"pageSize";
NSString * _Nonnull const kHttpDialogueHttpPostCmd_logic = @"logic";
NSString * _Nonnull const kHttpDialogueHttpPostCmd_filters = @"filters";
NSString * _Nonnull const kHttpDialogueHttpPostCmd_key = @"key";
NSString * _Nonnull const kHttpDialogueHttpPostCmd_opt = @"opt";
NSString * _Nonnull const kHttpDialogueHttpPostCmd_type = @"type";
NSString * _Nonnull const kHttpDialogueHttpPostCmd_value = @"value";
